﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Interop;
using Articles.ThreadingTutorial.Sample1;

//Some namespace mappings
using WinForms = System.Windows.Forms;
using Articles.ThreadingTutorial.Sample2;

namespace Articles.ThreadingTutorial
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        /// <summary>
        /// Initializes the MainWindow object.
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Called when user wants to close the window.
        /// </summary>
        private void OnCmdCloseClick(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Called when user wants to see the BackgroundWorker sample within a Windows.Forms window.
        /// </summary>
        private void OnCmdBackgroundWorkerWinFormsClick(object sender, RoutedEventArgs e)
        {
            Sample1Form sampleForms = new Sample1Form();

            HwndSource source = (HwndSource)HwndSource.FromVisual(this);
            sampleForms.ShowDialog(new WinFormsWrapper(source.Handle));
        }

        /// <summary>
        /// Called when user wants to see the BackgroundWorker sample within a Wpf window.
        /// </summary>
        private void OnCmdBackgroundWorkerWpfClick(object sender, RoutedEventArgs e)
        {
            Sample1Window window = new Sample1Window();
            window.Owner = this;
            window.ShowDialog();
        }

        /// <summary>
        /// Called when user wants to see the ThreadPool sample.
        /// </summary>
        private void OnCmdThreadPoolSampleConsoleClick(object sender, RoutedEventArgs e)
        {
            this.IsEnabled = false;
            Sample2Console.Run();
            this.IsEnabled = true;
        }

        //*********************************************************************
        //*********************************************************************
        //*********************************************************************
        public class WinFormsWrapper : WinForms.IWin32Window
        {
            private IntPtr m_handle;

            /// <summary>
            /// Creates a wrapper arrount the given handle.
            /// </summary>
            public WinFormsWrapper(IntPtr handle)
            {
                m_handle = handle;
            }

            /// <summary>
            /// Gets the handle of the window.
            /// </summary>
            public IntPtr Handle
            {
                get { return m_handle; }
            }
        }
    }
}
